//This is a class that will be used to create a separate thread.
//Its sole purpose will be to output a message to screen and then sleep for a random amount of time (less than 5 seconds).

public class CustomThread extends Thread
{
   //------------------------------------------------------------------------------
   //Data fields
   //
   //threadNumber - Simply the number of the thread.  Not used in this application.
   //------------------------------------------------------------------------------
   
   public int threadNumber;
   
   //------------------------------------------------------------------------------
   //The constructor.  This will allow us to pass a number to each thread.  
   //This could be useful in more complex applications.
   //------------------------------------------------------------------------------
   
   public CustomThread(int number)
   {
      threadNumber = number;
   }

   //------------------------------------------------------------------------------
   //The run method.  This method is automatically executed when the thead is
   //started.  For animation that can go on forever, this thread needs an infinite
   //loop.
   //------------------------------------------------------------------------------

   public void run()
   {
      while(true)
      {
         //output message
         System.out.println("Thread #" + threadNumber + ": Working");
         
         //Try to sleep for a random amount of time.  Unfortunately, this has
         //to be done inside a try statement which makes this code look quite
         //ugly.
         
         int delay = (int)(Math.random() * 5000);  //delay of 0 to 5 seconds
         try 
         {
            System.out.println("Thread #" + threadNumber + ": Sleeping for " + delay);
            Thread.sleep(delay);
         }
         catch (InterruptedException e) 
         {
            break;
         }
      }
   }     
}